

// APT-generated file.

package org.carrot2.source.microsoft;

//Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

import java.util.*;
import javax.annotation.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.microsoft.Bing2DocumentSource} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.microsoft.Bing2DocumentSource")
public final class Bing2DocumentSourceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.microsoft.Bing2DocumentSource";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "Bing2DocumentSource";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "A base <code>IDocumentSource</code> serving requests to Microsoft Bing API, version 2";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "We model this into separate subclasses, specific to a particular request type (web, image, news). In theory one could request web and news results at once, but in practice this is difficult when paging is also needed (because they have different limits).";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.appid);
        ownAttrs.add(attributes.market);
        ownAttrs.add(attributes.adult);
        ownAttrs.add(attributes.options);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.microsoft.Bing2DocumentSourceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.microsoft.Bing2DocumentSourceDescriptor.attributes.market);
        allAttrs.add(org.carrot2.source.microsoft.Bing2DocumentSourceDescriptor.attributes.adult);
        allAttrs.add(org.carrot2.source.microsoft.Bing2DocumentSourceDescriptor.attributes.options);
        allAttrs.add(org.carrot2.source.MultipageSearchEngineDescriptor.attributes.searchMode);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.start);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.results);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.query);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.resultsTotal);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.documents);
        allAttrs.add(org.carrot2.source.SearchEngineBaseDescriptor.attributes.compressed);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.microsoft.Bing2DocumentSource} component.
     */
    public static class Keys  extends org.carrot2.source.MultipageSearchEngineDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing2DocumentSource#appid}. */
        public static final String APPID = "Bing2DocumentSource.appid";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing2DocumentSource#market}. */
        public static final String MARKET = "Bing2DocumentSource.market";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing2DocumentSource#adult}. */
        public static final String ADULT = "Bing2DocumentSource.adult";
        /** Attribute key for: {@link org.carrot2.source.microsoft.Bing2DocumentSource#options}. */
        public static final String OPTIONS = "Bing2DocumentSource.options";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.microsoft.Bing2DocumentSource} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo appid = 
            new AttributeInfo(
                "Bing2DocumentSource.appid",
                "org.carrot2.source.microsoft.Bing2DocumentSource",
                "appid",
                "Microsoft-assigned application ID for querying the API. Please <strong>generate\nyour own ID</strong> for production deployments and branches off the Carrot2.org's\ncode.",
                "Application ID",
                "Microsoft-assigned application ID for querying the API",
                "Please <strong>generate your own ID</strong> for production deployments and branches off the Carrot2.org's code.",
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo market = 
            new AttributeInfo(
                "Bing2DocumentSource.market",
                "org.carrot2.source.microsoft.Bing2DocumentSource",
                "market",
                "Language and country/region information for the request.",
                "Market",
                "Language and country/region information for the request",
                null,
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.BASIC,
                null
            );

        /**
         *          */
        public final AttributeInfo adult = 
            new AttributeInfo(
                "Bing2DocumentSource.adult",
                "org.carrot2.source.microsoft.Bing2DocumentSource",
                "adult",
                "Adult search restriction (porn filter).",
                "Safe Search",
                "Adult search restriction (porn filter)",
                null,
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo options = 
            new AttributeInfo(
                "Bing2DocumentSource.options",
                "org.carrot2.source.microsoft.Bing2DocumentSource",
                "options",
                "Miscellaneous request options. Bing provides the following options:\n<ul>\n<li>DisableLocationDetection</li>\n<li>EnableHighlighting</li>\n</ul>\n\n<p>Options should be space-separated.</p>",
                "Request Options",
                "Miscellaneous request options",
                "Bing provides the following options: <ul> <li>DisableLocationDetection</li> <li>EnableHighlighting</li> </ul> <p>Options should be space-separated.</p>",
                "Miscellaneous",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.microsoft.Bing2DocumentSource} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.MultipageSearchEngineDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Microsoft-assigned application ID for querying the API. Please <strong>generate
your own ID</strong> for production deployments and branches off the Carrot2.org's
code.
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#appid 
         */
        public AttributeBuilder appid(java.lang.String value)
        {
            map.put("Bing2DocumentSource.appid", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Language and country/region information for the request.
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#market 
         */
        public AttributeBuilder market(org.carrot2.source.microsoft.MarketOption value)
        {
            map.put("Bing2DocumentSource.market", value);
            return this;
        }
        
        
        
        /**
         * Language and country/region information for the request.
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#market
         */
        public AttributeBuilder market(Class<? extends org.carrot2.source.microsoft.MarketOption> clazz)
        {
            map.put("Bing2DocumentSource.market", clazz);
            return this;
        }
        
        
        
        
        
        /**
         * Adult search restriction (porn filter).
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#adult 
         */
        public AttributeBuilder adult(org.carrot2.source.microsoft.AdultOption value)
        {
            map.put("Bing2DocumentSource.adult", value);
            return this;
        }
        
        
        
        /**
         * Adult search restriction (porn filter).
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#adult
         */
        public AttributeBuilder adult(Class<? extends org.carrot2.source.microsoft.AdultOption> clazz)
        {
            map.put("Bing2DocumentSource.adult", clazz);
            return this;
        }
        
        
        
        
        
        /**
         * Miscellaneous request options. Bing provides the following options:
<ul>
<li>DisableLocationDetection</li>
<li>EnableHighlighting</li>
</ul>

<p>Options should be space-separated.</p>
         * 
         * @see org.carrot2.source.microsoft.Bing2DocumentSource#options 
         */
        public AttributeBuilder options(java.lang.String value)
        {
            map.put("Bing2DocumentSource.options", value);
            return this;
        }
        
        
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
